import { computed as F, watch as ue, ref as X, defineComponent as xe, provide as Te, toRefs as Fe, useSlots as $e, onMounted as Re, openBlock as b, createElementBlock as C, Fragment as q, createElementVNode as E, normalizeClass as U, unref as e, renderSlot as T, normalizeProps as B, mergeProps as j, renderList as Q, toDisplayString as V, withModifiers as Ve, createCommentVNode as te, createTextVNode as W } from "vue";
const Ae = {
  items: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of data objects, should be a flat array."
  },
  values: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of value objects representing the metrics"
  },
  rows: {
    type: Array,
    default: () => [],
    description: "Array of row objects representing the dimensions on rows"
  },
  column: {
    type: Object,
    default: null,
    description: "Single column object representing the dimension on columns"
  },
  locale: {
    type: String,
    default: "en-US",
    description: "Locale setting for the table."
  },
  currentPage: {
    type: Number,
    default: 1,
    description: "Current page number."
  },
  noRowsCustom: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to use custom rows when no data is available."
  },
  emptyMessage: {
    type: String,
    default: "No Available Data",
    description: "Message to display when there is no available data."
  },
  filterOptions: {
    type: Array,
    default: null,
    description: "Array of filter options for the table."
  },
  hideFooter: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table footer."
  },
  hideHeader: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table header."
  },
  loading: {
    type: Boolean,
    default: !1,
    description: "Indicates whether the table is in a loading state."
  },
  rowsPerPage: {
    type: Number,
    default: 25,
    description: "Number of rows per page."
  },
  searchField: {
    type: [String, Array],
    default: "",
    description: "Field or fields to search within."
  },
  rowsItems: {
    type: Array,
    default: () => [25, 50, 100]
  },
  rowsOfPageSeparatorMessage: {
    type: String,
    default: "of"
  },
  searchValue: {
    type: String,
    default: "",
    description: "Value to search for within the specified field(s)."
  },
  showIndex: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to display an index column."
  },
  showIndexSymbol: {
    type: String,
    default: "#",
    description: "Symbol used for the index column."
  },
  showIndexClass: {
    type: String,
    default: "",
    description: "Class used for the index column."
  },
  oddRowClass: {
    type: String,
    default: "odd-row",
    description: "CSS class applied to odd-numbered rows."
  },
  evenRowClass: {
    type: String,
    default: "even-row",
    description: "CSS class applied to even-numbered rows."
  },
  oddRowCellClass: {
    type: String,
    default: "odd-row-cell",
    description: "CSS class applied to cells in odd-numbered rows."
  },
  evenRowCellClass: {
    type: String,
    default: "even-row-cell",
    description: "CSS class applied to cells in even-numbered rows."
  },
  sortBy: {
    type: String,
    default: "",
    description: "Field or fields to sort by."
  },
  sortType: {
    type: String,
    default: "asc",
    description: "Sort type or types (ascending or descending)."
  },
  sortColumnValue: {
    type: String,
    default: "",
    description: "Sort columnValue when column is active"
  },
  tableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table element."
  },
  innerTableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the inner table element."
  },
  headerClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table header element."
  },
  mustSort: {
    type: Boolean,
    default: !1,
    description: "Indicates whether sorting is required."
  },
  tableNodeId: {
    type: String,
    default: "",
    description: "ID attribute for the table element."
  },
  nullFillText: {
    type: String,
    default: "-",
    description: "Text to be shown if cellvalue is null"
  }
};
function _(s, o) {
  if (s.includes(".")) {
    const v = s.split("."), { length: d } = v;
    let r, f = 0;
    for (; f < d; ) {
      if (f === 0)
        r = o[v[0]];
      else if (r && typeof r == "object")
        r = r[v[f]];
      else {
        r = "";
        break;
      }
      f += 1;
    }
    return r ?? "";
  }
  return o[s];
}
function we(s, o, v, d) {
  return s == null ? d : Array.isArray(s) ? s.join(", ") : (o.formatFunc ? s = o.formatFunc(s) : o.numberFormat && (s = new Intl.NumberFormat(v, o.numberFormat).format(s)), o.prefix && (s = o.prefix + s), o.suffix && (s = s + o.suffix), s);
}
function Ne(s, o, v, d) {
  const r = _(s.value, o);
  return we(r, s, v, d);
}
function Me(s, o, v, d, r) {
  var x;
  let f;
  return s.columnValue ? f = (x = o.items.find((S) => S[v.value] === s.columnValue)) == null ? void 0 : x[s.value] : f = _(s.value, o.rows), we(f, s, d, r);
}
function Oe(s, o, v, d, r, f, x, S, h) {
  const z = (c) => {
    if (typeof x.value == "string" && x.value !== "")
      return _(x.value, c);
    if (Array.isArray(x.value)) {
      let a = "";
      return x.value.forEach((g) => {
        a += _(g, c);
      }), a;
    }
    return Object.values(c).join(" ");
  }, A = F(() => {
    if (r.value) {
      const c = f.value.map((g) => g.value), a = d.value.reduce((g, P) => {
        const w = c.map((n) => P[n]).join("|"), k = g.find((n) => n.key === w);
        if (k)
          k.items.push(P);
        else {
          const n = Object.fromEntries(Object.entries(P).filter(([p]) => c.includes(p)));
          g.push({ key: w, rows: n, items: [P] });
        }
        return g;
      }, []);
      if (S.value !== "") {
        const g = new RegExp(S.value, "i");
        return a.filter((P) => g.test(P.key));
      }
      return a;
    }
    if (S.value !== "") {
      const c = new RegExp(S.value, "i");
      return d.value.filter((a) => c.test(z(a)));
    }
    return d.value;
  }), N = F(() => {
    let c = [...A.value];
    return r.value ? c : v.value ? (v.value.forEach((a) => {
      c = c.filter((g) => {
        const { field: P, comparison: w, criteria: k } = a;
        if (typeof w == "function")
          return w(_(P, g), k);
        const n = _(P, g);
        if (n === null)
          return !1;
        switch (w) {
          case "=":
            return n === k;
          case "!=":
            return n !== k;
          case ">":
            return n > k;
          case "<":
            return n < k;
          case "<=":
            return n <= k;
          case ">=":
            return n >= k;
          case "between":
            return n >= Math.min(...k) && n <= Math.max(...k);
          case "in":
            return Array.isArray(k) ? k.includes(n) : !0;
          default:
            return n === k;
        }
      });
    }), c) : A.value;
  });
  ue(
    N,
    (c) => {
      v.value && h("updateFilter", c);
    },
    { immediate: !0, deep: !0 }
  );
  const M = F(() => {
    var n;
    if (o.value === null)
      return N.value;
    const c = [...N.value], { sortBy: a, sortDesc: g, sortColumnValue: P } = o.value, w = (n = s.value.find((p) => p.value === a)) == null ? void 0 : n.sortFunc;
    return c.sort((p, u) => {
      var R, $, K, Z;
      let l, m;
      return r.value ? P ? (l = w ? w((R = p.items.find((G) => G[r.value.value] === P)) == null ? void 0 : R[a]) : ($ = p.items.find((G) => G[r.value.value] === P)) == null ? void 0 : $[a], m = w ? w((K = u.items.find((G) => G[r.value.value] === P)) == null ? void 0 : K[a]) : (Z = u.items.find((G) => G[r.value.value] === P)) == null ? void 0 : Z[a]) : (l = w ? w(p.rows[a]) : p.rows[a], m = w ? w(u.rows[a]) : u.rows[a]) : (l = w ? w(_(a, p)) : _(a, p), m = w ? w(_(a, u)) : _(a, u)), l == null && m != null ? 1 : l != null && m == null ? -1 : l == null && m == null ? 0 : l < m ? g ? 1 : -1 : l > m ? g ? -1 : 1 : 0;
    });
  }), Y = F(() => M.value.length);
  return {
    totalItems: M,
    totalItemsLength: Y
  };
}
function Be(s, o, v, d, r, f, x, S, h, z, A, N) {
  const M = F(() => r.value ? [...new Set(s.value.map((n) => n[r.value.value]))] : []), c = X(
    ((n, p, u) => n && n !== "" ? {
      sortBy: n,
      sortDesc: p === "desc",
      sortColumnValue: u
    } : null)(h.value, z.value, A.value)
  );
  let a = [];
  const g = F(() => {
    if (r.value) {
      const u = M.value.flatMap((l) => d.value.map((R) => ({
        ...R,
        columnValue: l
      })));
      a = [
        ...v.value.map((l) => ({ ...l, type: "tableRow" })),
        ...u.map((l) => ({ ...l, type: "tableValue" }))
      ];
    } else
      a = [
        ...v.value.map((u) => ({ ...u, type: "tableRow" })),
        ...d.value.map((u) => ({ ...u, type: "tableValue" }))
      ];
    const n = a.map((u) => {
      const l = Object.assign(u);
      return l.sortable && (l.sortType = "none"), c.value && l.value === c.value.sortBy && c.value.sortColumnValue ? c.value.sortColumnValue === l.columnValue ? l.sortType = c.value.sortDesc ? "desc" : "asc" : l.sortType = "none" : c.value && l.value === c.value.sortBy && (l.sortType = c.value.sortDesc ? "desc" : "asc"), l;
    });
    let p = [];
    return x.value ? p = [{
      text: o.value,
      value: "index",
      cssClass: S.value
    }, ...n] : p = n, p;
  }), P = F(() => {
    const n = [];
    if (r.value) {
      const p = g.value.reduce(
        (u, l) => {
          const m = l.columnValue;
          let R;
          l.columnValue ? r.value.formatFunc ? R = r.value.formatFunc(l.columnValue) : R = l.columnValue : R = null;
          const $ = u[u.length - 1];
          return $ && $.text === R && !$.isIndex && $.originalText === m ? $.count++ : u.push({
            type: "column",
            isIndex: l.value === "index",
            text: R,
            originalText: m,
            count: 1,
            cssClass: l.cssClass ?? ""
          }), u;
        },
        []
      );
      n.push(p);
    }
    if (g.value.findIndex((p) => p.parent) > -1) {
      const p = g.value.reduce(
        (u, l) => {
          var K;
          const m = ((K = l.parent) == null ? void 0 : K.text) || null, R = l.columnValue, $ = u[u.length - 1];
          return $ && $.text === m && !$.isIndex && $.columnValue === R ? $.count++ : u.push({
            type: "parent",
            isIndex: l.value === "index",
            columnValue: R,
            text: m,
            count: 1,
            cssClass: l.cssClass ?? ""
          }), u;
        },
        []
      );
      n.push(p);
    }
    return n;
  }), w = F(() => g.value.map((n) => n.value));
  return {
    columnDomain: M,
    clientSortOptions: c,
    headerColumns: w,
    headersForRenderParents: P,
    headersForRender: g,
    updateSortField: (n, p, u = !1, l = void 0) => {
      let m = null;
      u ? m = p === "none" ? null : p : p === "none" ? m = "asc" : p === "asc" ? m = "desc" : m = f.value ? "asc" : null, m === null ? c.value = null : c.value = {
        sortBy: n,
        sortDesc: m === "desc",
        sortColumnValue: l
      }, N("updateSort", {
        sortColumnValue: l,
        sortType: m,
        sortBy: n
      });
    }
  };
}
function je(s, o) {
  const v = F(() => s.value.findIndex((f) => f === o.value) === -1 ? [o.value, ...s.value] : s.value), d = X(o.value);
  return {
    rowsItemsComputed: v,
    rowsPerPageRef: d,
    updateRowsPerPage: (f) => {
      d.value = f;
    }
  };
}
function De(s, o, v, d) {
  const r = X(s.value), f = F(() => Math.ceil(v.value / d.value)), x = F(
    () => f.value === 0 || r.value === f.value
  ), S = F(() => r.value === 1);
  return {
    currentPaginationNumber: r,
    maxPaginationNumber: f,
    isLastPage: x,
    isFirstPage: S,
    nextPage: () => {
      v.value !== 0 && (x.value || o.value || (r.value += 1));
    },
    prevPage: () => {
      v.value !== 0 && (S.value || o.value || (r.value -= 1));
    },
    updatePage: (M) => {
      o.value || (r.value = M);
    },
    updateCurrentPaginationNumber: (M) => {
      r.value = M;
    }
  };
}
function Ee(s, o, v, d, r) {
  const f = F(() => (s.value - 1) * o.value + 1), x = F(() => Math.min(d.value.length, s.value * o.value)), S = F(() => o.value === -1 ? d.value : d.value.slice(f.value - 1, x.value)), h = F(() => v.value ? r.value ? S.value.map((A, N) => (A.rows = { index: f.value + N, ...A.rows }, A)) : S.value.map((A, N) => ({ index: f.value + N, ...A })) : S.value), z = F(() => h.value);
  return {
    currentPageFirstIndex: f,
    currentPageLastIndex: x,
    pageItems: z
  };
}
const Le = [
  { name: "scroll", description: "Triggered when scrolling" },
  { name: "clickRow", description: "Triggered when a row is clicked" },
  { name: "clickCell", description: "Triggered when a cell is clicked" },
  { name: "updateSort", description: "Triggered when sorting is updated" },
  { name: "updateFilter", description: "Triggered when filtering is updated" },
  { name: "updatePageItems", description: "Triggered when page items are updated" },
  { name: "updateTotalItems", description: "Triggered when total items are updated" },
  { name: "mouseover", description: "Triggered when mouse is over" },
  { name: "mouseleave", description: "Triggered when mouse leaves" }
], _e = Le.map((s) => s.name), ze = ["id"], Ge = ["colspan"], He = { class: "header" }, qe = {
  key: 3,
  class: "header-text"
}, We = ["onClick"], Ue = { class: "header" }, Ke = {
  key: 3,
  class: "header-text"
}, Je = ["id"], Qe = ["role", "onClick", "onMouseover", "onMouseleave"], Xe = { id: "errors" }, Ye = { style: { color: "red" } }, Ze = { key: 6 }, et = /* @__PURE__ */ xe({
  __name: "PivotDataTable",
  props: Ae,
  emits: _e,
  setup(s, { expose: o, emit: v }) {
    const d = X([]), r = X();
    Te("dataTable", r);
    const f = s, {
      values: x,
      rows: S,
      column: h,
      locale: z,
      tableNodeId: A,
      currentPage: N,
      filterOptions: M,
      emptyMessage: Y,
      noRowsCustom: c,
      items: a,
      loading: g,
      mustSort: P,
      rowsItems: w,
      rowsPerPage: k,
      searchField: n,
      searchValue: p,
      showIndex: u,
      sortBy: l,
      sortType: m,
      sortColumnValue: R,
      showIndexSymbol: $,
      showIndexClass: K,
      nullFillText: Z,
      hideFooter: G
    } = Fe(f), O = $e(), ee = v, { clientSortOptions: he, headersForRenderParents: be, headersForRender: L, updateSortField: se } = Be(
      a,
      $,
      S,
      x,
      h,
      P,
      u,
      K,
      l,
      m,
      R,
      ee
    ), { totalItems: ve, totalItemsLength: re } = Oe(
      L,
      he,
      M,
      a,
      h,
      S,
      n,
      p,
      ee
    ), { rowsItemsComputed: Ce, rowsPerPageRef: le, updateRowsPerPage: Se } = je(w, k), { currentPaginationNumber: ie, maxPaginationNumber: de, isLastPage: fe, isFirstPage: ge, nextPage: ne, prevPage: oe, updatePage: ae } = De(N, g, re, le), { currentPageFirstIndex: ce, currentPageLastIndex: pe, pageItems: me } = Ee(
      ie,
      le,
      u,
      ve,
      h
    ), Pe = (i, D, t, I) => {
      ee("clickCell", i, D, t, I);
    };
    ue(le, () => {
      ae(1);
    }), ue([p, M], () => {
      ae(1);
    }), ue(
      [a, h],
      () => {
        ke();
      },
      { immediate: !0 }
    );
    const ye = X(!1);
    function ke() {
      d.value = [], h.value && Array.isArray(h.value) ? d.value.push({
        type: "propError",
        text: "column is of type Array"
      }) : h.value && Ie() && d.value.push({
        type: "dataShapeError",
        text: "duplicate item Objects (by rows * columns) found in items"
      });
    }
    Re(() => {
      r.value.addEventListener("scroll", () => {
        ye.value = r.value.scrollLeft > 0;
      });
    }), o({
      currentPageFirstIndex: ce,
      currentPageLastIndex: pe,
      clientItemsLength: re,
      totalItems: ve,
      maxPaginationNumber: de,
      currentPaginationNumber: ie,
      isLastPage: fe,
      isFirstPage: ge,
      nextPage: ne,
      prevPage: oe,
      updatePage: ae,
      updateSortField: se,
      rowsPerPageOptions: Ce,
      rowsPerPageActiveOption: le,
      updateRowsPerPageActiveOption: Se
    });
    function Ie() {
      const i = [...S.value.map((t) => t.value), h.value.value], D = /* @__PURE__ */ new Set();
      for (let t = 0; t < a.value.length; t++) {
        const I = i.map((y) => a.value[t][y]).join("|");
        if (D.has(I))
          return !0;
        D.add(I);
      }
      return !1;
    }
    return (i, D) => (b(), C(q, null, [
      E("div", {
        ref_key: "dataTable",
        ref: r,
        class: U(["vue3-pivot-data-table", [i.tableClassName]]),
        onScroll: D[0] || (D[0] = (t) => i.$emit("scroll", t))
      }, [
        E("table", {
          id: e(A),
          class: U({
            [i.innerTableClassName]: !0,
            "show-shadow": ye.value
          })
        }, [
          e(O)["customize-headers"] ? T(i.$slots, "customize-headers", B(j({ key: 0 }, { headersForRender: e(L), updateSortField: e(se) })), void 0, !0) : e(L).length && !i.hideHeader ? (b(), C("thead", {
            key: 1,
            class: U([i.headerClassName])
          }, [
            (b(!0), C(q, null, Q(e(be), (t, I) => (b(), C("tr", {
              key: "headerRowGroup" + I
            }, [
              (b(!0), C(q, null, Q(t, (y, H) => (b(), C("th", {
                key: "columnHeader" + H,
                colspan: y.count,
                class: U([
                  {
                    shadow: H === 0,
                    [y.cssClass ?? ""]: !0,
                    [y.type ?? ""]: !0
                  }
                ])
              }, [
                E("span", He, [
                  e(O)[`header-${y.type}-${y.text}`] ? T(i.$slots, `header-${y.type}-${y.text}`, B(j({ key: 0 }, y)), void 0, !0) : e(O)[`header-${y.type}`] ? T(i.$slots, `header-${y.type}`, B(j({ key: 1 }, y)), void 0, !0) : e(O).header ? T(i.$slots, "header", B(j({ key: 2 }, y)), void 0, !0) : (b(), C("span", qe, V(y.text), 1))
                ])
              ], 10, Ge))), 128))
            ]))), 128)),
            E("tr", null, [
              (b(!0), C(q, null, Q(e(L), (t, I) => (b(), C("th", {
                key: I,
                role: "button",
                tabindex: 0,
                class: U([
                  {
                    sortable: t.sortable,
                    none: t.sortable && t.sortType === "none",
                    desc: t.sortable && t.sortType === "desc",
                    asc: t.sortable && t.sortType === "asc",
                    shadow: I === 0,
                    [t.cssClass ?? ""]: !0,
                    [t.type ?? ""]: !0
                  }
                ]),
                onClick: Ve((y) => t.sortable && t.sortType ? e(se)(t.value, t.sortType, !1, t.columnValue) : null, ["stop"])
              }, [
                E("span", Ue, [
                  e(O)[`header-${t.value}`] ? T(i.$slots, `header-${t.value}`, B(j({ key: 0 }, t)), void 0, !0) : e(O)[`header-${t.value.toLowerCase()}`] ? T(i.$slots, `header-${t.value.toLowerCase()}`, B(j({ key: 1 }, t)), void 0, !0) : e(O).header ? T(i.$slots, "header", B(j({ key: 2 }, t)), void 0, !0) : (b(), C("span", Ke, V(t.text), 1)),
                  t.sortable && e(O)["sort-icon"] ? T(i.$slots, "sort-icon", B(j({ key: 4 }, t)), void 0, !0) : t.sortable ? (b(), C("i", {
                    key: t.sortType ? t.sortType : "none",
                    class: U(["sortType-icon", { desc: t.sortType === "desc" }])
                  }, null, 2)) : te("", !0)
                ])
              ], 10, We))), 128))
            ])
          ], 2)) : te("", !0),
          E("tbody", null, [
            (b(!0), C(q, null, Q(e(me), (t, I) => (b(), C("tr", {
              id: `row-${I}`,
              key: I,
              class: U([{ [i.oddRowClass]: (I + 1) % 2 === 0 }, { [i.evenRowClass]: I % 2 === 0 }]),
              role: "button",
              tabindex: 0
            }, [
              (b(!0), C(q, null, Q(e(L), (y, H) => (b(), C("td", {
                key: H,
                role: e(L)[H].clickable || e(L)[H].hoverable ? "button" : "",
                tabindex: "0",
                class: U([
                  {
                    [i.oddRowCellClass]: (I + 1) % 2 === 0,
                    [i.evenRowCellClass]: I % 2 === 0,
                    shadow: H === 0,
                    [y.cssClass ?? ""]: !0,
                    [y.type ?? ""]: !0
                  }
                ]),
                onClick: (J) => Pe(t, e(L)[H], I, J),
                onMouseover: (J) => ee("mouseover", t, e(L)[H], J),
                onMouseleave: (J) => ee("mouseleave", t, J)
              }, [
                e(O)[`item-${y.value}`] ? T(i.$slots, `item-${y.value}`, B(j(
                  { key: 0 },
                  e(h) && y.columnValue ? t.items.find((J) => J[e(h).value] === y.columnValue) : e(h) ? t.rows : t
                )), void 0, !0) : e(O).item ? T(i.$slots, "item", B(j({ key: 1 }, { column: e(h), item: t })), void 0, !0) : e(h) ? (b(), C(q, { key: 2 }, [
                  W(V(e(Me)(y, t, e(h), e(z), e(Z))), 1)
                ], 64)) : (b(), C(q, { key: 3 }, [
                  W(V(e(Ne)(y, t, e(z), e(Z))), 1)
                ], 64))
              ], 42, Qe))), 128))
            ], 10, Je))), 128))
          ]),
          e(O)["customize-footers"] ? T(i.$slots, "customize-footers", B(j({ key: 2 }, {
            headersForRender: e(L),
            updateSortField: e(se)
          })), void 0, !0) : te("", !0)
        ], 10, ze)
      ], 34),
      d.value.length ? T(i.$slots, "errors", { key: 0 }, () => [
        E("div", Xe, [
          E("ul", null, [
            (b(!0), C(q, null, Q(d.value, (t, I) => (b(), C("li", {
              key: "error" + I
            }, [
              E("span", Ye, V(t.type) + ":", 1),
              W(" " + V(t.text), 1)
            ]))), 128))
          ])
        ])
      ], !0) : e(g) ? T(i.$slots, "loading", { key: 1 }, () => [
        W(" Slot: loading ")
      ], !0) : !e(a).length && !e(g) && e(c) ? T(i.$slots, "no-rows-custom", { key: 2 }, () => [
        W(" Slot: no-rows-custom ")
      ], !0) : !e(a).length && !e(g) ? T(i.$slots, "no-rows", { key: 3 }, () => [
        W(V(e(Y)), 1)
      ], !0) : !e(me).length && !e(g) ? T(i.$slots, "empty-message", { key: 4 }, () => [
        W(V(e(Y)), 1)
      ], !0) : te("", !0),
      e(O).footer ? T(i.$slots, "footer", B(j({ key: 5 }, {
        currentPageFirstIndex: e(ce),
        currentPageLastIndex: e(pe),
        rowsOfPageSeparatorMessage: i.rowsOfPageSeparatorMessage,
        totalItemsLength: e(re),
        isFirstPage: e(ge),
        isLastPage: e(fe),
        currentPaginationNumber: e(ie),
        maxPaginationNumber: e(de),
        nextPage: e(ne),
        prevPage: e(oe),
        updatePage: e(ae)
      })), void 0, !0) : e(G) ? te("", !0) : (b(), C("div", Ze, [
        W(V(`${e(ce)}–${e(pe)}`) + " " + V(i.rowsOfPageSeparatorMessage) + " " + V(e(re)) + " ", 1),
        E("button", {
          onClick: D[1] || (D[1] = //@ts-ignore
          (...t) => e(oe) && e(oe)(...t))
        }, V("<")),
        W(" " + V(e(N)) + " of " + V(e(de)) + " ", 1),
        E("button", {
          onClick: D[2] || (D[2] = //@ts-ignore
          (...t) => e(ne) && e(ne)(...t))
        }, ">")
      ]))
    ], 64));
  }
});
const tt = (s, o) => {
  const v = s.__vccOpts || s;
  for (const [d, r] of o)
    v[d] = r;
  return v;
}, lt = /* @__PURE__ */ tt(et, [["__scopeId", "data-v-746d5adc"]]);
export {
  lt as default
};
